/* Application.c generated by valac 0.56.1, the Vala compiler
 * generated from Application.vala, do not modify */

/*
* Copyright 2017-2020 elementary, Inc. (https://elementary.io)
*           2014-2016 Fabio Zaramella <ffabio.96.x@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License version 3 as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <handy.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <errno.h>
#include <locale.h>

#define SCREENSHOT_APPLICATION_SAVE_FOLDER _ ("Screenshots")
#define SCREENSHOT_APPLICATION_CAPTURE_AREA N_ ("Capture area")
#define SCREENSHOT_APPLICATION_CAPTURE_STRING N_ ("Capture the whole screen")
#define SCREENSHOT_APPLICATION_CAPTURE_WIN N_ ("Capture active window")
#define SCREENSHOT_APPLICATION_DELAY N_ ("Take screenshot after specified delay")
#define SCREENSHOT_APPLICATION_SECONDS N_ ("Seconds")
#define SCREENSHOT_APPLICATION_INCLUDE_POINTER N_ ("Include the pointer with the screenshot")
#define SCREENSHOT_APPLICATION_REDACT_TEXT N_ ("Redact system text")
#define SCREENSHOT_APPLICATION_CLIPBOARD N_ ("Save screenshot to clipboard")
#define GETTEXT_PACKAGE "io.elementary.screenshot"
#define LOCALEDIR "/usr/share/locale"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SCREENSHOT_TYPE_APPLICATION (screenshot_application_get_type ())
#define SCREENSHOT_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SCREENSHOT_TYPE_APPLICATION, ScreenshotApplication))
#define SCREENSHOT_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SCREENSHOT_TYPE_APPLICATION, ScreenshotApplicationClass))
#define SCREENSHOT_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SCREENSHOT_TYPE_APPLICATION))
#define SCREENSHOT_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SCREENSHOT_TYPE_APPLICATION))
#define SCREENSHOT_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SCREENSHOT_TYPE_APPLICATION, ScreenshotApplicationClass))

typedef struct _ScreenshotApplication ScreenshotApplication;
typedef struct _ScreenshotApplicationClass ScreenshotApplicationClass;
typedef struct _ScreenshotApplicationPrivate ScreenshotApplicationPrivate;

#define SCREENSHOT_TYPE_SCREENSHOT_WINDOW (screenshot_screenshot_window_get_type ())
#define SCREENSHOT_SCREENSHOT_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SCREENSHOT_TYPE_SCREENSHOT_WINDOW, ScreenshotScreenshotWindow))
#define SCREENSHOT_SCREENSHOT_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SCREENSHOT_TYPE_SCREENSHOT_WINDOW, ScreenshotScreenshotWindowClass))
#define SCREENSHOT_IS_SCREENSHOT_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SCREENSHOT_TYPE_SCREENSHOT_WINDOW))
#define SCREENSHOT_IS_SCREENSHOT_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SCREENSHOT_TYPE_SCREENSHOT_WINDOW))
#define SCREENSHOT_SCREENSHOT_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SCREENSHOT_TYPE_SCREENSHOT_WINDOW, ScreenshotScreenshotWindowClass))

typedef struct _ScreenshotScreenshotWindow ScreenshotScreenshotWindow;
typedef struct _ScreenshotScreenshotWindowClass ScreenshotScreenshotWindowClass;
enum  {
	SCREENSHOT_APPLICATION_0_PROPERTY,
	SCREENSHOT_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* screenshot_application_properties[SCREENSHOT_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ScreenshotApplication {
	GtkApplication parent_instance;
	ScreenshotApplicationPrivate * priv;
};

struct _ScreenshotApplicationClass {
	GtkApplicationClass parent_class;
};

struct _ScreenshotApplicationPrivate {
	ScreenshotScreenshotWindow* window;
};

struct _Block1Data {
	int _ref_count_;
	ScreenshotApplication* self;
	GraniteSettings* granite_settings;
	GtkSettings* gtk_settings;
};

static gint ScreenshotApplication_private_offset;
static gpointer screenshot_application_parent_class = NULL;
static gboolean screenshot_application_win;
static gboolean screenshot_application_area;
static gboolean screenshot_application_screen;
static gint screenshot_application_delay;
static gboolean screenshot_application_grab_pointer;
static gboolean screenshot_application_redact;
static gboolean screenshot_application_clipboard;
static gboolean screenshot_application_area = FALSE;
static gboolean screenshot_application_clipboard = FALSE;
static gboolean screenshot_application_grab_pointer = FALSE;
static gboolean screenshot_application_redact = FALSE;
static gboolean screenshot_application_screen = FALSE;
static gboolean screenshot_application_win = FALSE;
static gint screenshot_application_delay = 1;

VALA_EXTERN GType screenshot_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ScreenshotApplication, g_object_unref)
VALA_EXTERN GType screenshot_screenshot_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ScreenshotScreenshotWindow, g_object_unref)
VALA_EXTERN ScreenshotApplication* screenshot_application_new (void);
VALA_EXTERN ScreenshotApplication* screenshot_application_construct (GType object_type);
static void screenshot_application_real_activate (GApplication* base);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda21_ (Block1Data* _data1_);
static void ___lambda21__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
VALA_EXTERN ScreenshotScreenshotWindow* screenshot_screenshot_window_new (void);
VALA_EXTERN ScreenshotScreenshotWindow* screenshot_screenshot_window_construct (GType object_type);
VALA_EXTERN ScreenshotScreenshotWindow* screenshot_screenshot_window_new_from_cmd (gint action,
                                                                       gint delay,
                                                                       gboolean grab_pointer,
                                                                       gboolean redact,
                                                                       gboolean clipboard);
VALA_EXTERN ScreenshotScreenshotWindow* screenshot_screenshot_window_construct_from_cmd (GType object_type,
                                                                             gint action,
                                                                             gint delay,
                                                                             gboolean grab_pointer,
                                                                             gboolean redact,
                                                                             gboolean clipboard);
VALA_EXTERN void screenshot_screenshot_window_take_clicked (ScreenshotScreenshotWindow* self);
static void __lambda22_ (ScreenshotApplication* self);
static void ___lambda22__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
VALA_EXTERN void screenshot_application_create_dir_if_missing (const gchar* path);
static gint screenshot_application_main (gchar** args,
                                  gint args_length1);
static GObject * screenshot_application_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void screenshot_application_finalize (GObject * obj);
static GType screenshot_application_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GOptionEntry SCREENSHOT_APPLICATION_OPTION_ENTRIES[8] = {{"window", 'w', (gint) 0, G_OPTION_ARG_NONE, &screenshot_application_win, SCREENSHOT_APPLICATION_CAPTURE_WIN, NULL}, {"area", 'r', (gint) 0, G_OPTION_ARG_NONE, &screenshot_application_area, SCREENSHOT_APPLICATION_CAPTURE_AREA, NULL}, {"screen", 's', (gint) 0, G_OPTION_ARG_NONE, &screenshot_application_screen, SCREENSHOT_APPLICATION_CAPTURE_STRING, NULL}, {"delay", 'd', (gint) 0, G_OPTION_ARG_INT, &screenshot_application_delay, SCREENSHOT_APPLICATION_DELAY, SCREENSHOT_APPLICATION_SECONDS}, {"grab-pointer", 'p', (gint) 0, G_OPTION_ARG_NONE, &screenshot_application_grab_pointer, SCREENSHOT_APPLICATION_INCLUDE_POINTER, NULL}, {"redact", 'e', (gint) 0, G_OPTION_ARG_NONE, &screenshot_application_redact, SCREENSHOT_APPLICATION_REDACT_TEXT, NULL}, {"clipboard", 'c', (gint) 0, G_OPTION_ARG_NONE, &screenshot_application_clipboard, SCREENSHOT_APPLICATION_CLIPBOARD, NULL}, {NULL}};

static inline gpointer
screenshot_application_get_instance_private (ScreenshotApplication* self)
{
	return G_STRUCT_MEMBER_P (self, ScreenshotApplication_private_offset);
}

ScreenshotApplication*
screenshot_application_construct (GType object_type)
{
	ScreenshotApplication * self = NULL;
	self = (ScreenshotApplication*) g_object_new (object_type, "application-id", "io.elementary.screenshot", "flags", G_APPLICATION_FLAGS_NONE, NULL);
	return self;
}

ScreenshotApplication*
screenshot_application_new (void)
{
	return screenshot_application_construct (SCREENSHOT_TYPE_APPLICATION);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		ScreenshotApplication* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->gtk_settings);
		_g_object_unref0 (_data1_->granite_settings);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda21_ (Block1Data* _data1_)
{
	ScreenshotApplication* self;
	GtkSettings* _tmp0_;
	GraniteSettings* _tmp1_;
	GraniteSettingsColorScheme _tmp2_;
	GraniteSettingsColorScheme _tmp3_;
	self = _data1_->self;
	_tmp0_ = _data1_->gtk_settings;
	_tmp1_ = _data1_->granite_settings;
	_tmp2_ = granite_settings_get_prefers_color_scheme (_tmp1_);
	_tmp3_ = _tmp2_;
	g_object_set (_tmp0_, "gtk-application-prefer-dark-theme", _tmp3_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, NULL);
}

static void
___lambda21__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda21_ (self);
}

static void
__lambda22_ (ScreenshotApplication* self)
{
	ScreenshotScreenshotWindow* _tmp0_;
	_tmp0_ = self->priv->window;
	if (_tmp0_ != NULL) {
		ScreenshotScreenshotWindow* _tmp1_;
		_tmp1_ = self->priv->window;
		gtk_widget_destroy ((GtkWidget*) _tmp1_);
	}
}

static void
___lambda22__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
	__lambda22_ ((ScreenshotApplication*) self);
}

static void
screenshot_application_real_activate (GApplication* base)
{
	ScreenshotApplication * self;
	Block1Data* _data1_;
	GtkIconTheme* default_theme = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	GraniteSettings* _tmp2_;
	GraniteSettings* _tmp3_;
	GtkSettings* _tmp4_;
	GtkSettings* _tmp5_;
	GtkSettings* _tmp6_;
	GraniteSettings* _tmp7_;
	GraniteSettingsColorScheme _tmp8_;
	GraniteSettingsColorScheme _tmp9_;
	GraniteSettings* _tmp10_;
	gint action = 0;
	GSimpleAction* quit_action = NULL;
	GSimpleAction* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar** _tmp22_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	self = (ScreenshotApplication*) base;
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = gtk_icon_theme_get_default ();
	default_theme = _tmp0_;
	_tmp1_ = default_theme;
	gtk_icon_theme_add_resource_path (_tmp1_, "/io/elementary/screenshot");
	_tmp2_ = granite_settings_get_default ();
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_data1_->granite_settings = _tmp3_;
	_tmp4_ = gtk_settings_get_default ();
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_data1_->gtk_settings = _tmp5_;
	_tmp6_ = _data1_->gtk_settings;
	_tmp7_ = _data1_->granite_settings;
	_tmp8_ = granite_settings_get_prefers_color_scheme (_tmp7_);
	_tmp9_ = _tmp8_;
	g_object_set (_tmp6_, "gtk-application-prefer-dark-theme", _tmp9_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, NULL);
	_tmp10_ = _data1_->granite_settings;
	g_signal_connect_data ((GObject*) _tmp10_, "notify::prefers-color-scheme", (GCallback) ___lambda21__g_object_notify, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	action = 0;
	if (screenshot_application_screen) {
		action = 1;
	}
	if (screenshot_application_win) {
		action = 2;
	}
	if (screenshot_application_area) {
		action = 3;
	}
	if (action == 0) {
		ScreenshotScreenshotWindow* _tmp11_;
		ScreenshotScreenshotWindow* _tmp15_;
		_tmp11_ = self->priv->window;
		if (_tmp11_ == NULL) {
			ScreenshotScreenshotWindow* _tmp12_;
			ScreenshotScreenshotWindow* _tmp13_;
			ScreenshotScreenshotWindow* _tmp14_;
			_tmp12_ = screenshot_screenshot_window_new ();
			g_object_ref_sink (_tmp12_);
			_g_object_unref0 (self->priv->window);
			self->priv->window = _tmp12_;
			_tmp13_ = self->priv->window;
			gtk_window_set_application ((GtkWindow*) _tmp13_, (GtkApplication*) self);
			_tmp14_ = self->priv->window;
			gtk_widget_show_all ((GtkWidget*) _tmp14_);
		}
		_tmp15_ = self->priv->window;
		gtk_window_present ((GtkWindow*) _tmp15_);
	} else {
		ScreenshotScreenshotWindow* _tmp16_;
		ScreenshotScreenshotWindow* _tmp17_;
		ScreenshotScreenshotWindow* _tmp18_;
		_tmp16_ = screenshot_screenshot_window_new_from_cmd (action, screenshot_application_delay, screenshot_application_grab_pointer, screenshot_application_redact, screenshot_application_clipboard);
		g_object_ref_sink (_tmp16_);
		_g_object_unref0 (self->priv->window);
		self->priv->window = _tmp16_;
		_tmp17_ = self->priv->window;
		gtk_window_set_application ((GtkWindow*) _tmp17_, (GtkApplication*) self);
		_tmp18_ = self->priv->window;
		screenshot_screenshot_window_take_clicked (_tmp18_);
	}
	_tmp19_ = g_simple_action_new ("quit", NULL);
	quit_action = _tmp19_;
	g_signal_connect_object (quit_action, "activate", (GCallback) ___lambda22__g_simple_action_activate, self, 0);
	g_action_map_add_action ((GActionMap*) self, (GAction*) quit_action);
	_tmp20_ = g_strdup ("<Control>q");
	_tmp21_ = g_strdup ("Escape");
	_tmp22_ = g_new0 (gchar*, 2 + 1);
	_tmp22_[0] = _tmp20_;
	_tmp22_[1] = _tmp21_;
	_tmp23_ = _tmp22_;
	_tmp23__length1 = 2;
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app.quit", _tmp23_);
	_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (quit_action);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

static GError*
vala_g_io_error_from_errno (gint err_no)
{
	const gchar* _tmp0_;
	GError* _tmp1_;
	GError* result;
	_tmp0_ = g_strerror (err_no);
	_tmp1_ = g_error_new (g_io_error_quark (), g_io_error_from_errno (err_no), "%s", _tmp0_);
	result = (GError*) _tmp1_;
	return result;
}

void
screenshot_application_create_dir_if_missing (const gchar* path)
{
	g_return_if_fail (path != NULL);
	if (mkdir (path, (mode_t) 0775) != 0) {
		gint err_no = 0;
		err_no = errno;
		if (err_no != EEXIST) {
			GError* _tmp0_;
			GError* _tmp1_;
			const gchar* _tmp2_;
			_tmp0_ = vala_g_io_error_from_errno (err_no);
			_tmp1_ = _tmp0_;
			_tmp2_ = _tmp1_->message;
			g_debug ("Application.vala:116: %s", _tmp2_);
			_g_error_free0 (_tmp1_);
		}
	}
}

static gint
screenshot_application_main (gchar** args,
                             gint args_length1)
{
	ScreenshotApplication* _tmp0_;
	ScreenshotApplication* _tmp1_;
	gint _tmp2_;
	gint result;
	_tmp0_ = screenshot_application_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_application_run ((GApplication*) _tmp1_, (gint) args_length1, args);
	_g_object_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

int
main (int argc,
      char ** argv)
{
	return screenshot_application_main (argv, argc);
}

static GObject *
screenshot_application_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ScreenshotApplication * self;
	parent_class = G_OBJECT_CLASS (screenshot_application_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCREENSHOT_TYPE_APPLICATION, ScreenshotApplication);
	setlocale (LC_ALL, "");
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	g_application_add_main_option_entries ((GApplication*) self, SCREENSHOT_APPLICATION_OPTION_ENTRIES);
	return obj;
}

static void
screenshot_application_class_init (ScreenshotApplicationClass * klass,
                                   gpointer klass_data)
{
	screenshot_application_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ScreenshotApplication_private_offset);
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) screenshot_application_real_activate;
	G_OBJECT_CLASS (klass)->constructor = screenshot_application_constructor;
	G_OBJECT_CLASS (klass)->finalize = screenshot_application_finalize;
}

static void
screenshot_application_instance_init (ScreenshotApplication * self,
                                      gpointer klass)
{
	self->priv = screenshot_application_get_instance_private (self);
	self->priv->window = NULL;
}

static void
screenshot_application_finalize (GObject * obj)
{
	ScreenshotApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCREENSHOT_TYPE_APPLICATION, ScreenshotApplication);
	_g_object_unref0 (self->priv->window);
	G_OBJECT_CLASS (screenshot_application_parent_class)->finalize (obj);
}

static GType
screenshot_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScreenshotApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) screenshot_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScreenshotApplication), 0, (GInstanceInitFunc) screenshot_application_instance_init, NULL };
	GType screenshot_application_type_id;
	screenshot_application_type_id = g_type_register_static (gtk_application_get_type (), "ScreenshotApplication", &g_define_type_info, 0);
	ScreenshotApplication_private_offset = g_type_add_instance_private (screenshot_application_type_id, sizeof (ScreenshotApplicationPrivate));
	return screenshot_application_type_id;
}

GType
screenshot_application_get_type (void)
{
	static volatile gsize screenshot_application_type_id__once = 0;
	if (g_once_init_enter (&screenshot_application_type_id__once)) {
		GType screenshot_application_type_id;
		screenshot_application_type_id = screenshot_application_get_type_once ();
		g_once_init_leave (&screenshot_application_type_id__once, screenshot_application_type_id);
	}
	return screenshot_application_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

