/* ScreenshotWindow.c generated by valac 0.56.1, the Vala compiler
 * generated from ScreenshotWindow.vala, do not modify */

/*
* Copyright 2017–2020 elementary, Inc. (https://elementary.io)
*           2014–2016 Fabio Zaramella <ffabio.96.x@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License version 3 as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <handy.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define SCREENSHOT_APPLICATION_SAVE_FOLDER _ ("Screenshots")
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SCREENSHOT_TYPE_SCREENSHOT_WINDOW (screenshot_screenshot_window_get_type ())
#define SCREENSHOT_SCREENSHOT_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SCREENSHOT_TYPE_SCREENSHOT_WINDOW, ScreenshotScreenshotWindow))
#define SCREENSHOT_SCREENSHOT_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SCREENSHOT_TYPE_SCREENSHOT_WINDOW, ScreenshotScreenshotWindowClass))
#define SCREENSHOT_IS_SCREENSHOT_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SCREENSHOT_TYPE_SCREENSHOT_WINDOW))
#define SCREENSHOT_IS_SCREENSHOT_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SCREENSHOT_TYPE_SCREENSHOT_WINDOW))
#define SCREENSHOT_SCREENSHOT_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SCREENSHOT_TYPE_SCREENSHOT_WINDOW, ScreenshotScreenshotWindowClass))

typedef struct _ScreenshotScreenshotWindow ScreenshotScreenshotWindow;
typedef struct _ScreenshotScreenshotWindowClass ScreenshotScreenshotWindowClass;
typedef struct _ScreenshotScreenshotWindowPrivate ScreenshotScreenshotWindowPrivate;
typedef enum  {
	SCREENSHOT_CAPTURE_TYPE_SCREEN,
	SCREENSHOT_CAPTURE_TYPE_CURRENT_WINDOW,
	SCREENSHOT_CAPTURE_TYPE_AREA
} ScreenshotCaptureType;

#define SCREENSHOT_TYPE_CAPTURE_TYPE (screenshot_capture_type_get_type ())

#define SCREENSHOT_TYPE_SCREENSHOT_BACKEND (screenshot_screenshot_backend_get_type ())
#define SCREENSHOT_SCREENSHOT_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SCREENSHOT_TYPE_SCREENSHOT_BACKEND, ScreenshotScreenshotBackend))
#define SCREENSHOT_SCREENSHOT_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SCREENSHOT_TYPE_SCREENSHOT_BACKEND, ScreenshotScreenshotBackendClass))
#define SCREENSHOT_IS_SCREENSHOT_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SCREENSHOT_TYPE_SCREENSHOT_BACKEND))
#define SCREENSHOT_IS_SCREENSHOT_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SCREENSHOT_TYPE_SCREENSHOT_BACKEND))
#define SCREENSHOT_SCREENSHOT_BACKEND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SCREENSHOT_TYPE_SCREENSHOT_BACKEND, ScreenshotScreenshotBackendClass))

typedef struct _ScreenshotScreenshotBackend ScreenshotScreenshotBackend;
typedef struct _ScreenshotScreenshotBackendClass ScreenshotScreenshotBackendClass;
enum  {
	SCREENSHOT_SCREENSHOT_WINDOW_0_PROPERTY,
	SCREENSHOT_SCREENSHOT_WINDOW_TO_CLIPBOARD_PROPERTY,
	SCREENSHOT_SCREENSHOT_WINDOW_CLOSE_ON_SAVE_PROPERTY,
	SCREENSHOT_SCREENSHOT_WINDOW_MOUSE_POINTER_PROPERTY,
	SCREENSHOT_SCREENSHOT_WINDOW_REDACT_PROPERTY,
	SCREENSHOT_SCREENSHOT_WINDOW_NUM_PROPERTIES
};
static GParamSpec* screenshot_screenshot_window_properties[SCREENSHOT_SCREENSHOT_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block3Data Block3Data;

#define SCREENSHOT_TYPE_SAVE_DIALOG (screenshot_save_dialog_get_type ())
#define SCREENSHOT_SAVE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SCREENSHOT_TYPE_SAVE_DIALOG, ScreenshotSaveDialog))
#define SCREENSHOT_SAVE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SCREENSHOT_TYPE_SAVE_DIALOG, ScreenshotSaveDialogClass))
#define SCREENSHOT_IS_SAVE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SCREENSHOT_TYPE_SAVE_DIALOG))
#define SCREENSHOT_IS_SAVE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SCREENSHOT_TYPE_SAVE_DIALOG))
#define SCREENSHOT_SAVE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SCREENSHOT_TYPE_SAVE_DIALOG, ScreenshotSaveDialogClass))

typedef struct _ScreenshotSaveDialog ScreenshotSaveDialog;
typedef struct _ScreenshotSaveDialogClass ScreenshotSaveDialogClass;
typedef struct _Block4Data Block4Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block5Data Block5Data;

struct _ScreenshotScreenshotWindow {
	HdyApplicationWindow parent_instance;
	ScreenshotScreenshotWindowPrivate * priv;
};

struct _ScreenshotScreenshotWindowClass {
	HdyApplicationWindowClass parent_class;
};

struct _ScreenshotScreenshotWindowPrivate {
	gboolean _to_clipboard;
	gboolean _close_on_save;
	gboolean _mouse_pointer;
	gboolean _redact;
	GSettings* settings;
	ScreenshotCaptureType capture_mode;
	gboolean from_command;
	gint delay;
	gint window_x;
	gint window_y;
	ScreenshotScreenshotBackend* backend;
	GtkLabel* pointer_label;
	GtkRadioButton* all;
	GtkSwitch* pointer_switch;
};

struct _Block3Data {
	int _ref_count_;
	ScreenshotScreenshotWindow* self;
	GdkPixbuf* screenshot;
};

struct _Block4Data {
	int _ref_count_;
	Block3Data * _data3_;
	ScreenshotSaveDialog* save_dialog;
};

struct _Block5Data {
	int _ref_count_;
	ScreenshotScreenshotWindow* self;
	GtkSpinButton* delay_spin;
	GtkSettings* gtk_settings;
};

static gint ScreenshotScreenshotWindow_private_offset;
static gpointer screenshot_screenshot_window_parent_class = NULL;

VALA_EXTERN GType screenshot_screenshot_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ScreenshotScreenshotWindow, g_object_unref)
VALA_EXTERN GType screenshot_capture_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType screenshot_screenshot_backend_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ScreenshotScreenshotBackend, g_object_unref)
VALA_EXTERN ScreenshotScreenshotWindow* screenshot_screenshot_window_new (void);
VALA_EXTERN ScreenshotScreenshotWindow* screenshot_screenshot_window_construct (GType object_type);
VALA_EXTERN ScreenshotScreenshotWindow* screenshot_screenshot_window_new_from_cmd (gint action,
                                                                       gint delay,
                                                                       gboolean grab_pointer,
                                                                       gboolean redact,
                                                                       gboolean clipboard);
VALA_EXTERN ScreenshotScreenshotWindow* screenshot_screenshot_window_construct_from_cmd (GType object_type,
                                                                             gint action,
                                                                             gint delay,
                                                                             gboolean grab_pointer,
                                                                             gboolean redact,
                                                                             gboolean clipboard);
VALA_EXTERN void screenshot_screenshot_window_set_close_on_save (ScreenshotScreenshotWindow* self,
                                                     gboolean value);
VALA_EXTERN void screenshot_screenshot_window_set_mouse_pointer (ScreenshotScreenshotWindow* self,
                                                     gboolean value);
VALA_EXTERN void screenshot_screenshot_window_set_redact (ScreenshotScreenshotWindow* self,
                                              gboolean value);
static void screenshot_screenshot_window_update_icons (ScreenshotScreenshotWindow* self,
                                                gboolean prefers_dark);
static void screenshot_screenshot_window_update_pointer_switch (ScreenshotScreenshotWindow* self);
VALA_EXTERN gboolean screenshot_screenshot_backend_get_can_screenshot_area_with_cursor (ScreenshotScreenshotBackend* self);
static void screenshot_screenshot_window_save_file (ScreenshotScreenshotWindow* self,
                                             const gchar* file_name,
                                             const gchar* format,
                                             gchar* folder_dir,
                                             GdkPixbuf* screenshot,
                                             GError** error);
VALA_EXTERN void screenshot_application_create_dir_if_missing (const gchar* path);
static void screenshot_screenshot_window_save_pixbuf (ScreenshotScreenshotWindow* self,
                                               GdkPixbuf* screenshot);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN GType screenshot_save_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ScreenshotSaveDialog, g_object_unref)
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
VALA_EXTERN ScreenshotSaveDialog* screenshot_save_dialog_new (GdkPixbuf* pixbuf,
                                                  GSettings* settings,
                                                  GtkWindow* parent);
VALA_EXTERN ScreenshotSaveDialog* screenshot_save_dialog_construct (GType object_type,
                                                        GdkPixbuf* pixbuf,
                                                        GSettings* settings,
                                                        GtkWindow* parent);
static void ___lambda12_ (Block4Data* _data4_,
                   gboolean response,
                   const gchar* folder_dir,
                   const gchar* output_name,
                   const gchar* format);
VALA_EXTERN gboolean screenshot_screenshot_window_get_close_on_save (ScreenshotScreenshotWindow* self);
static void screenshot_screenshot_window_show_error_dialog (ScreenshotScreenshotWindow* self,
                                                     const gchar* error_message);
static void ____lambda12__screenshot_save_dialog_save_response (ScreenshotSaveDialog* _sender,
                                                         gboolean response,
                                                         const gchar* folder_dir,
                                                         const gchar* output_name,
                                                         const gchar* format,
                                                         gpointer self);
static void ___lambda13_ (ScreenshotScreenshotWindow* self);
static void ____lambda13__gtk_dialog_close (GtkDialog* _sender,
                                     gpointer self);
VALA_EXTERN gboolean screenshot_screenshot_window_get_to_clipboard (ScreenshotScreenshotWindow* self);
VALA_EXTERN void screenshot_screenshot_window_take_clicked (ScreenshotScreenshotWindow* self);
VALA_EXTERN void screenshot_screenshot_backend_capture (ScreenshotScreenshotBackend* self,
                                            ScreenshotCaptureType type,
                                            gint delay,
                                            gboolean include_pointer,
                                            gboolean redact,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN GdkPixbuf* screenshot_screenshot_backend_capture_finish (ScreenshotScreenshotBackend* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
VALA_EXTERN gboolean screenshot_screenshot_window_get_mouse_pointer (ScreenshotScreenshotWindow* self);
VALA_EXTERN gboolean screenshot_screenshot_window_get_redact (ScreenshotScreenshotWindow* self);
static void __lambda14_ (ScreenshotScreenshotWindow* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda14__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void screenshot_screenshot_window_set_to_clipboard (ScreenshotScreenshotWindow* self,
                                                    gboolean value);
static GObject * screenshot_screenshot_window_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
VALA_EXTERN ScreenshotScreenshotBackend* screenshot_screenshot_backend_new (void);
VALA_EXTERN ScreenshotScreenshotBackend* screenshot_screenshot_backend_construct (GType object_type);
VALA_EXTERN gboolean screenshot_screenshot_backend_get_can_conceal_text (ScreenshotScreenshotBackend* self);
static void _screenshot_screenshot_window___lambda15_ (ScreenshotScreenshotWindow* self);
static void __screenshot_screenshot_window___lambda15__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                           gpointer self);
static void _screenshot_screenshot_window___lambda16_ (ScreenshotScreenshotWindow* self);
static void __screenshot_screenshot_window___lambda16__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                           gpointer self);
static void _screenshot_screenshot_window___lambda17_ (ScreenshotScreenshotWindow* self);
static void __screenshot_screenshot_window___lambda17__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                           gpointer self);
static void _screenshot_screenshot_window___lambda18_ (Block5Data* _data5_);
static void __screenshot_screenshot_window___lambda18__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                               gpointer self);
static void _screenshot_screenshot_window_take_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void _screenshot_screenshot_window___lambda19_ (ScreenshotScreenshotWindow* self);
static void __screenshot_screenshot_window___lambda19__gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void _screenshot_screenshot_window___lambda20_ (Block5Data* _data5_);
static void __screenshot_screenshot_window___lambda20__g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self);
static void screenshot_screenshot_window_finalize (GObject * obj);
static GType screenshot_screenshot_window_get_type_once (void);
static void _vala_screenshot_screenshot_window_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_screenshot_screenshot_window_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
screenshot_screenshot_window_get_instance_private (ScreenshotScreenshotWindow* self)
{
	return G_STRUCT_MEMBER_P (self, ScreenshotScreenshotWindow_private_offset);
}

ScreenshotScreenshotWindow*
screenshot_screenshot_window_construct (GType object_type)
{
	ScreenshotScreenshotWindow * self = NULL;
	self = (ScreenshotScreenshotWindow*) g_object_new (object_type, "resizable", FALSE, "to-clipboard", FALSE, NULL);
	return self;
}

ScreenshotScreenshotWindow*
screenshot_screenshot_window_new (void)
{
	return screenshot_screenshot_window_construct (SCREENSHOT_TYPE_SCREENSHOT_WINDOW);
}

ScreenshotScreenshotWindow*
screenshot_screenshot_window_construct_from_cmd (GType object_type,
                                                 gint action,
                                                 gint delay,
                                                 gboolean grab_pointer,
                                                 gboolean redact,
                                                 gboolean clipboard)
{
	ScreenshotScreenshotWindow * self = NULL;
	self = (ScreenshotScreenshotWindow*) g_object_new (object_type, "to-clipboard", clipboard, NULL);
	screenshot_screenshot_window_set_close_on_save (self, TRUE);
	self->priv->from_command = TRUE;
	screenshot_screenshot_window_set_mouse_pointer (self, grab_pointer);
	self->priv->delay = MAX (0, delay);
	screenshot_screenshot_window_set_redact (self, redact);
	switch (action) {
		case 1:
		{
			self->priv->capture_mode = SCREENSHOT_CAPTURE_TYPE_SCREEN;
			break;
		}
		case 2:
		{
			self->priv->capture_mode = SCREENSHOT_CAPTURE_TYPE_CURRENT_WINDOW;
			break;
		}
		case 3:
		{
			self->priv->capture_mode = SCREENSHOT_CAPTURE_TYPE_AREA;
			break;
		}
		default:
		break;
	}
	return self;
}

ScreenshotScreenshotWindow*
screenshot_screenshot_window_new_from_cmd (gint action,
                                           gint delay,
                                           gboolean grab_pointer,
                                           gboolean redact,
                                           gboolean clipboard)
{
	return screenshot_screenshot_window_construct_from_cmd (SCREENSHOT_TYPE_SCREENSHOT_WINDOW, action, delay, grab_pointer, redact, clipboard);
}

static void
screenshot_screenshot_window_update_icons (ScreenshotScreenshotWindow* self,
                                           gboolean prefers_dark)
{
	g_return_if_fail (self != NULL);
	if (prefers_dark) {
		GtkRadioButton* _tmp0_;
		GtkImage* _tmp1_;
		GtkImage* _tmp2_;
		_tmp0_ = self->priv->all;
		_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("grab-screen-symbolic-dark", (GtkIconSize) GTK_ICON_SIZE_DND);
		g_object_ref_sink (_tmp1_);
		_tmp2_ = _tmp1_;
		gtk_button_set_image ((GtkButton*) _tmp0_, (GtkWidget*) _tmp2_);
		_g_object_unref0 (_tmp2_);
	} else {
		GtkRadioButton* _tmp3_;
		GtkImage* _tmp4_;
		GtkImage* _tmp5_;
		_tmp3_ = self->priv->all;
		_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name ("grab-screen-symbolic", (GtkIconSize) GTK_ICON_SIZE_DND);
		g_object_ref_sink (_tmp4_);
		_tmp5_ = _tmp4_;
		gtk_button_set_image ((GtkButton*) _tmp3_, (GtkWidget*) _tmp5_);
		_g_object_unref0 (_tmp5_);
	}
}

static void
screenshot_screenshot_window_update_pointer_switch (ScreenshotScreenshotWindow* self)
{
	gboolean _tmp0_ = FALSE;
	ScreenshotScreenshotBackend* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean sensitive = FALSE;
	GtkLabel* _tmp4_;
	GtkSwitch* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->backend;
	_tmp2_ = screenshot_screenshot_backend_get_can_screenshot_area_with_cursor (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->capture_mode != SCREENSHOT_CAPTURE_TYPE_AREA;
	}
	sensitive = _tmp0_;
	_tmp4_ = self->priv->pointer_label;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, sensitive);
	_tmp5_ = self->priv->pointer_switch;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, sensitive);
}

static void
screenshot_screenshot_window_save_file (ScreenshotScreenshotWindow* self,
                                        const gchar* file_name,
                                        const gchar* format,
                                        gchar* folder_dir,
                                        GdkPixbuf* screenshot,
                                        GError** error)
{
	gchar* full_file_name = NULL;
	gchar* _tmp0_;
	gchar* folder_from_settings = NULL;
	gchar* _tmp1_;
	gint attempt = 0;
	const gchar* _tmp25_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file_name != NULL);
	g_return_if_fail (format != NULL);
	g_return_if_fail (folder_dir != NULL);
	g_return_if_fail (screenshot != NULL);
	_tmp0_ = g_strdup ("");
	full_file_name = _tmp0_;
	_tmp1_ = g_strdup ("");
	folder_from_settings = _tmp1_;
	if (g_strcmp0 (folder_dir, "") == 0) {
		GSettings* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp2_ = self->priv->settings;
		_tmp3_ = g_settings_get_string (_tmp2_, "folder-dir");
		_g_free0 (folder_from_settings);
		folder_from_settings = _tmp3_;
		_tmp4_ = folder_from_settings;
		if (g_strcmp0 (_tmp4_, "") != 0) {
			const gchar* _tmp5_;
			gchar* _tmp6_;
			_tmp5_ = folder_from_settings;
			_tmp6_ = g_strdup (_tmp5_);
			_g_free0 (folder_dir);
			folder_dir = _tmp6_;
		} else {
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			_tmp7_ = g_get_user_special_dir (G_USER_DIRECTORY_PICTURES);
			_tmp8_ = g_strdup_printf ("%c", (gint) G_DIR_SEPARATOR);
			_tmp9_ = _tmp8_;
			_tmp10_ = g_strconcat (_tmp7_, _tmp9_, NULL);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_strconcat (_tmp11_, SCREENSHOT_APPLICATION_SAVE_FOLDER, NULL);
			_g_free0 (folder_dir);
			folder_dir = _tmp12_;
			_g_free0 (_tmp11_);
			_g_free0 (_tmp9_);
		}
		screenshot_application_create_dir_if_missing (folder_dir);
	}
	attempt = 0;
	{
		gboolean _tmp13_ = FALSE;
		_tmp13_ = TRUE;
		while (TRUE) {
			gint _tmp24_;
			if (!_tmp13_) {
				const gchar* _tmp14_;
				GFile* _tmp15_;
				GFile* _tmp16_;
				gboolean _tmp17_;
				_tmp14_ = full_file_name;
				_tmp15_ = g_file_new_for_path (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = !g_file_query_exists (_tmp16_, NULL);
				_g_object_unref0 (_tmp16_);
				if (_tmp17_) {
					break;
				}
			}
			_tmp13_ = FALSE;
			if (attempt == 0) {
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				_tmp18_ = g_strdup_printf ("%s.%s", file_name, format);
				_tmp19_ = _tmp18_;
				_tmp20_ = g_build_filename (folder_dir, _tmp19_, NULL);
				_g_free0 (full_file_name);
				full_file_name = _tmp20_;
				_g_free0 (_tmp19_);
			} else {
				gchar* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				_tmp21_ = g_strdup_printf ("%s (%d).%s", file_name, attempt, format);
				_tmp22_ = _tmp21_;
				_tmp23_ = g_build_filename (folder_dir, _tmp22_, NULL);
				_g_free0 (full_file_name);
				full_file_name = _tmp23_;
				_g_free0 (_tmp22_);
			}
			_tmp24_ = attempt;
			attempt = _tmp24_ + 1;
		}
	}
	_tmp25_ = full_file_name;
	gdk_pixbuf_save (screenshot, _tmp25_, format, &_inner_error0_, NULL);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_free0 (folder_from_settings);
		_g_free0 (full_file_name);
		_g_free0 (folder_dir);
		return;
	}
	_g_free0 (folder_from_settings);
	_g_free0 (full_file_name);
	_g_free0 (folder_dir);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		ScreenshotScreenshotWindow* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->screenshot);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		ScreenshotScreenshotWindow* self;
		self = _data4_->_data3_->self;
		_g_object_unref0 (_data4_->save_dialog);
		block3_data_unref (_data4_->_data3_);
		_data4_->_data3_ = NULL;
		g_slice_free (Block4Data, _data4_);
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
___lambda12_ (Block4Data* _data4_,
              gboolean response,
              const gchar* folder_dir,
              const gchar* output_name,
              const gchar* format)
{
	Block3Data* _data3_;
	ScreenshotScreenshotWindow* self;
	ScreenshotSaveDialog* _tmp0_;
	GError* _inner_error0_ = NULL;
	_data3_ = _data4_->_data3_;
	self = _data3_->self;
	g_return_if_fail (folder_dir != NULL);
	g_return_if_fail (output_name != NULL);
	g_return_if_fail (format != NULL);
	_tmp0_ = _data4_->save_dialog;
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
	if (response) {
		gchar** formats = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar** _tmp6_;
		gint formats_length1;
		gint _formats_size_;
		gchar* output = NULL;
		gchar* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		_tmp1_ = g_strdup (".png");
		_tmp2_ = g_strdup (".jpg");
		_tmp3_ = g_strdup (".jpeg");
		_tmp4_ = g_strdup (".bmp");
		_tmp5_ = g_strdup (".tiff");
		_tmp6_ = g_new0 (gchar*, 5 + 1);
		_tmp6_[0] = _tmp1_;
		_tmp6_[1] = _tmp2_;
		_tmp6_[2] = _tmp3_;
		_tmp6_[3] = _tmp4_;
		_tmp6_[4] = _tmp5_;
		formats = _tmp6_;
		formats_length1 = 5;
		_formats_size_ = formats_length1;
		_tmp7_ = g_strdup (output_name);
		output = _tmp7_;
		_tmp8_ = formats;
		_tmp8__length1 = formats_length1;
		{
			gchar** type_collection = NULL;
			gint type_collection_length1 = 0;
			gint _type_collection_size_ = 0;
			gint type_it = 0;
			type_collection = _tmp8_;
			type_collection_length1 = _tmp8__length1;
			for (type_it = 0; type_it < type_collection_length1; type_it = type_it + 1) {
				gchar* _tmp9_;
				gchar* type = NULL;
				_tmp9_ = g_strdup (type_collection[type_it]);
				type = _tmp9_;
				{
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
					_tmp10_ = output;
					_tmp11_ = type;
					_tmp12_ = string_replace (_tmp10_, _tmp11_, "");
					_g_free0 (output);
					output = _tmp12_;
					_g_free0 (type);
				}
			}
		}
		{
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gboolean _tmp15_;
			_tmp13_ = output;
			_tmp14_ = g_strdup (folder_dir);
			screenshot_screenshot_window_save_file (self, _tmp13_, format, _tmp14_, _data3_->screenshot, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp15_ = self->priv->_close_on_save;
			if (_tmp15_) {
				gtk_widget_destroy ((GtkWidget*) self);
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp16_;
			const gchar* _tmp17_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp16_ = e;
			_tmp17_ = _tmp16_->message;
			screenshot_screenshot_window_show_error_dialog (self, _tmp17_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (output);
			formats = (_vala_array_free (formats, formats_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_free0 (output);
		formats = (_vala_array_free (formats, formats_length1, (GDestroyNotify) g_free), NULL);
	}
}

static void
____lambda12__screenshot_save_dialog_save_response (ScreenshotSaveDialog* _sender,
                                                    gboolean response,
                                                    const gchar* folder_dir,
                                                    const gchar* output_name,
                                                    const gchar* format,
                                                    gpointer self)
{
	___lambda12_ (self, response, folder_dir, output_name, format);
}

static void
___lambda13_ (ScreenshotScreenshotWindow* self)
{
	gboolean _tmp0_;
	_tmp0_ = self->priv->_close_on_save;
	if (_tmp0_) {
		gtk_widget_destroy ((GtkWidget*) self);
	}
}

static void
____lambda13__gtk_dialog_close (GtkDialog* _sender,
                                gpointer self)
{
	___lambda13_ ((ScreenshotScreenshotWindow*) self);
}

static void
screenshot_screenshot_window_save_pixbuf (ScreenshotScreenshotWindow* self,
                                          GdkPixbuf* screenshot)
{
	Block3Data* _data3_;
	GdkPixbuf* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screenshot != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (screenshot);
	_g_object_unref0 (_data3_->screenshot);
	_data3_->screenshot = _tmp0_;
	if (self->priv->from_command == FALSE) {
		Block4Data* _data4_;
		GSettings* _tmp1_;
		ScreenshotSaveDialog* _tmp2_;
		ScreenshotSaveDialog* _tmp3_;
		ScreenshotSaveDialog* _tmp4_;
		ScreenshotSaveDialog* _tmp5_;
		_data4_ = g_slice_new0 (Block4Data);
		_data4_->_ref_count_ = 1;
		_data4_->_data3_ = block3_data_ref (_data3_);
		_tmp1_ = self->priv->settings;
		_tmp2_ = screenshot_save_dialog_new (_data3_->screenshot, _tmp1_, (GtkWindow*) self);
		g_object_ref_sink (_tmp2_);
		_data4_->save_dialog = _tmp2_;
		_tmp3_ = _data4_->save_dialog;
		g_signal_connect_data (_tmp3_, "save-response", (GCallback) ____lambda12__screenshot_save_dialog_save_response, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
		_tmp4_ = _data4_->save_dialog;
		g_signal_connect_object ((GtkDialog*) _tmp4_, "close", (GCallback) ____lambda13__gtk_dialog_close, self, 0);
		_tmp5_ = _data4_->save_dialog;
		gtk_widget_show_all ((GtkWidget*) _tmp5_);
		block4_data_unref (_data4_);
		_data4_ = NULL;
	} else {
		gboolean _tmp6_;
		_tmp6_ = self->priv->_to_clipboard;
		if (_tmp6_) {
			GdkDisplay* _tmp7_;
			GtkClipboard* _tmp8_;
			_tmp7_ = gtk_widget_get_display ((GtkWidget*) self);
			_tmp8_ = gtk_clipboard_get_default (_tmp7_);
			gtk_clipboard_set_image (_tmp8_, _data3_->screenshot);
		} else {
			gchar* date_time = NULL;
			GDateTime* _tmp9_;
			GDateTime* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* file_name = NULL;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* format = NULL;
			GSettings* _tmp15_;
			gchar* _tmp16_;
			_tmp9_ = g_date_time_new_now_local ();
			_tmp10_ = _tmp9_;
			_tmp11_ = g_date_time_format (_tmp10_, "%Y-%m-%d %H.%M.%S");
			_tmp12_ = _tmp11_;
			_g_date_time_unref0 (_tmp10_);
			date_time = _tmp12_;
			_tmp13_ = date_time;
			_tmp14_ = g_strdup_printf (_ ("Screenshot from %s"), _tmp13_);
			file_name = _tmp14_;
			_tmp15_ = self->priv->settings;
			_tmp16_ = g_settings_get_string (_tmp15_, "format");
			format = _tmp16_;
			{
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				_tmp17_ = file_name;
				_tmp18_ = format;
				_tmp19_ = g_strdup ("");
				screenshot_screenshot_window_save_file (self, _tmp17_, _tmp18_, _tmp19_, _data3_->screenshot, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp20_;
				const gchar* _tmp21_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp20_ = e;
				_tmp21_ = _tmp20_->message;
				screenshot_screenshot_window_show_error_dialog (self, _tmp21_);
				_g_error_free0 (e);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (format);
				_g_free0 (file_name);
				_g_free0 (date_time);
				block3_data_unref (_data3_);
				_data3_ = NULL;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_g_free0 (format);
			_g_free0 (file_name);
			_g_free0 (date_time);
		}
		gtk_widget_destroy ((GtkWidget*) self);
	}
	block3_data_unref (_data3_);
	_data3_ = NULL;
}

static void
__lambda14_ (ScreenshotScreenshotWindow* self,
             GObject* obj,
             GAsyncResult* res)
{
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp7_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	pixbuf = NULL;
	{
		GdkPixbuf* _tmp0_ = NULL;
		ScreenshotScreenshotBackend* _tmp1_;
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
		_tmp1_ = self->priv->backend;
		_tmp2_ = screenshot_screenshot_backend_capture_finish (_tmp1_, res, &_inner_error0_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
				goto __catch0_g_io_error_cancelled;
			}
			goto __catch0_g_error;
		}
		_tmp3_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (pixbuf);
		pixbuf = _tmp3_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_io_error_cancelled:
	{
		gboolean _tmp4_;
		g_clear_error (&_inner_error0_);
		_tmp4_ = self->priv->_close_on_save;
		if (_tmp4_) {
			gtk_widget_destroy ((GtkWidget*) self);
			_g_object_unref0 (pixbuf);
			return;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		screenshot_screenshot_window_show_error_dialog (self, _tmp6_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (pixbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp7_ = pixbuf;
	if (_tmp7_ != NULL) {
		GdkPixbuf* _tmp8_;
		_tmp8_ = pixbuf;
		screenshot_screenshot_window_save_pixbuf (self, _tmp8_);
	}
	if (self->priv->from_command == FALSE) {
		gtk_window_move ((GtkWindow*) self, self->priv->window_x, self->priv->window_y);
		gtk_window_present ((GtkWindow*) self);
	}
	_g_object_unref0 (pixbuf);
}

static void
___lambda14__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda14_ ((ScreenshotScreenshotWindow*) self, source_object, res);
	g_object_unref (self);
}

void
screenshot_screenshot_window_take_clicked (ScreenshotScreenshotWindow* self)
{
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	ScreenshotScreenshotBackend* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	gtk_window_get_position ((GtkWindow*) self, &_tmp0_, &_tmp1_);
	self->priv->window_x = _tmp0_;
	self->priv->window_y = _tmp1_;
	gtk_widget_hide ((GtkWidget*) self);
	_tmp2_ = self->priv->backend;
	_tmp3_ = self->priv->_mouse_pointer;
	_tmp4_ = self->priv->_redact;
	screenshot_screenshot_backend_capture (_tmp2_, self->priv->capture_mode, self->priv->delay, _tmp3_, _tmp4_, ___lambda14__gasync_ready_callback, g_object_ref (self));
}

static void
screenshot_screenshot_window_show_error_dialog (ScreenshotScreenshotWindow* self,
                                                const gchar* error_message)
{
	GraniteMessageDialog* dialog = NULL;
	GraniteMessageDialog* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (error_message != NULL);
	_tmp0_ = granite_message_dialog_new_with_image_from_icon_name (_ ("Could not capture screenshot"), _ ("Image not saved"), "dialog-error", GTK_BUTTONS_CLOSE);
	g_object_ref_sink (_tmp0_);
	dialog = _tmp0_;
	granite_message_dialog_show_error_details (dialog, error_message);
	gtk_dialog_run ((GtkDialog*) dialog);
	gtk_widget_destroy ((GtkWidget*) dialog);
	_g_object_unref0 (dialog);
}

gboolean
screenshot_screenshot_window_get_to_clipboard (ScreenshotScreenshotWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_to_clipboard;
	return result;
}

static void
screenshot_screenshot_window_set_to_clipboard (ScreenshotScreenshotWindow* self,
                                               gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = screenshot_screenshot_window_get_to_clipboard (self);
	if (old_value != value) {
		self->priv->_to_clipboard = value;
		g_object_notify_by_pspec ((GObject *) self, screenshot_screenshot_window_properties[SCREENSHOT_SCREENSHOT_WINDOW_TO_CLIPBOARD_PROPERTY]);
	}
}

gboolean
screenshot_screenshot_window_get_close_on_save (ScreenshotScreenshotWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_close_on_save;
	return result;
}

void
screenshot_screenshot_window_set_close_on_save (ScreenshotScreenshotWindow* self,
                                                gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = screenshot_screenshot_window_get_close_on_save (self);
	if (old_value != value) {
		self->priv->_close_on_save = value;
		g_object_notify_by_pspec ((GObject *) self, screenshot_screenshot_window_properties[SCREENSHOT_SCREENSHOT_WINDOW_CLOSE_ON_SAVE_PROPERTY]);
	}
}

gboolean
screenshot_screenshot_window_get_mouse_pointer (ScreenshotScreenshotWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_mouse_pointer;
	return result;
}

void
screenshot_screenshot_window_set_mouse_pointer (ScreenshotScreenshotWindow* self,
                                                gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = screenshot_screenshot_window_get_mouse_pointer (self);
	if (old_value != value) {
		self->priv->_mouse_pointer = value;
		g_object_notify_by_pspec ((GObject *) self, screenshot_screenshot_window_properties[SCREENSHOT_SCREENSHOT_WINDOW_MOUSE_POINTER_PROPERTY]);
	}
}

gboolean
screenshot_screenshot_window_get_redact (ScreenshotScreenshotWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_redact;
	return result;
}

void
screenshot_screenshot_window_set_redact (ScreenshotScreenshotWindow* self,
                                         gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = screenshot_screenshot_window_get_redact (self);
	if (old_value != value) {
		self->priv->_redact = value;
		g_object_notify_by_pspec ((GObject *) self, screenshot_screenshot_window_properties[SCREENSHOT_SCREENSHOT_WINDOW_REDACT_PROPERTY]);
	}
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		ScreenshotScreenshotWindow* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->gtk_settings);
		_g_object_unref0 (_data5_->delay_spin);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static void
_screenshot_screenshot_window___lambda15_ (ScreenshotScreenshotWindow* self)
{
	GSettings* _tmp0_;
	self->priv->capture_mode = SCREENSHOT_CAPTURE_TYPE_SCREEN;
	_tmp0_ = self->priv->settings;
	g_settings_set_enum (_tmp0_, "last-capture-mode", (gint) self->priv->capture_mode);
	screenshot_screenshot_window_update_pointer_switch (self);
}

static void
__screenshot_screenshot_window___lambda15__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                      gpointer self)
{
	_screenshot_screenshot_window___lambda15_ ((ScreenshotScreenshotWindow*) self);
}

static void
_screenshot_screenshot_window___lambda16_ (ScreenshotScreenshotWindow* self)
{
	GSettings* _tmp0_;
	self->priv->capture_mode = SCREENSHOT_CAPTURE_TYPE_CURRENT_WINDOW;
	_tmp0_ = self->priv->settings;
	g_settings_set_enum (_tmp0_, "last-capture-mode", (gint) self->priv->capture_mode);
	screenshot_screenshot_window_update_pointer_switch (self);
}

static void
__screenshot_screenshot_window___lambda16__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                      gpointer self)
{
	_screenshot_screenshot_window___lambda16_ ((ScreenshotScreenshotWindow*) self);
}

static void
_screenshot_screenshot_window___lambda17_ (ScreenshotScreenshotWindow* self)
{
	GSettings* _tmp0_;
	self->priv->capture_mode = SCREENSHOT_CAPTURE_TYPE_AREA;
	_tmp0_ = self->priv->settings;
	g_settings_set_enum (_tmp0_, "last-capture-mode", (gint) self->priv->capture_mode);
	screenshot_screenshot_window_update_pointer_switch (self);
	gtk_window_present ((GtkWindow*) self);
}

static void
__screenshot_screenshot_window___lambda17__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                      gpointer self)
{
	_screenshot_screenshot_window___lambda17_ ((ScreenshotScreenshotWindow*) self);
}

static void
_screenshot_screenshot_window___lambda18_ (Block5Data* _data5_)
{
	ScreenshotScreenshotWindow* self;
	GtkSpinButton* _tmp0_;
	self = _data5_->self;
	_tmp0_ = _data5_->delay_spin;
	self->priv->delay = gtk_spin_button_get_value_as_int (_tmp0_);
}

static void
__screenshot_screenshot_window___lambda18__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                          gpointer self)
{
	_screenshot_screenshot_window___lambda18_ (self);
}

static void
_screenshot_screenshot_window_take_clicked_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
	screenshot_screenshot_window_take_clicked ((ScreenshotScreenshotWindow*) self);
}

static void
_screenshot_screenshot_window___lambda19_ (ScreenshotScreenshotWindow* self)
{
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
__screenshot_screenshot_window___lambda19__gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
	_screenshot_screenshot_window___lambda19_ ((ScreenshotScreenshotWindow*) self);
}

static void
_screenshot_screenshot_window___lambda20_ (Block5Data* _data5_)
{
	ScreenshotScreenshotWindow* self;
	GtkSettings* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data5_->self;
	_tmp0_ = _data5_->gtk_settings;
	g_object_get (_tmp0_, "gtk-application-prefer-dark-theme", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	screenshot_screenshot_window_update_icons (self, _tmp2_);
}

static void
__screenshot_screenshot_window___lambda20__g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self)
{
	_screenshot_screenshot_window___lambda20_ (self);
}

static GObject *
screenshot_screenshot_window_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ScreenshotScreenshotWindow * self;
	Block5Data* _data5_;
	ScreenshotScreenshotBackend* _tmp0_;
	GtkRadioButton* _tmp1_;
	GtkRadioButton* _tmp2_;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GtkRadioButton* _tmp5_;
	GtkRadioButton* curr_window = NULL;
	GtkRadioButton* _tmp6_;
	GtkRadioButton* _tmp7_;
	GtkRadioButton* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	GtkRadioButton* _tmp11_;
	GtkRadioButton* selection = NULL;
	GtkRadioButton* _tmp12_;
	GtkRadioButton* _tmp13_;
	GtkRadioButton* _tmp14_;
	GtkImage* _tmp15_;
	GtkImage* _tmp16_;
	GtkRadioButton* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkSwitch* _tmp20_;
	GtkSwitch* _tmp21_;
	GtkLabel* close_label = NULL;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkSwitch* close_switch = NULL;
	GtkSwitch* _tmp24_;
	GtkSwitch* _tmp25_;
	GtkLabel* redact_label = NULL;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkSwitch* redact_switch = NULL;
	GtkSwitch* _tmp28_;
	GtkSwitch* _tmp29_;
	ScreenshotScreenshotBackend* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	GtkLabel* delay_label = NULL;
	GtkLabel* _tmp35_;
	GtkLabel* _tmp36_;
	GtkSpinButton* _tmp37_;
	GtkButton* take_btn = NULL;
	GtkButton* _tmp38_;
	GtkButton* _tmp39_;
	GtkStyleContext* _tmp40_;
	GtkButton* _tmp41_;
	GtkButton* _tmp42_;
	GtkButton* close_btn = NULL;
	GtkButton* _tmp43_;
	GtkGrid* radio_grid = NULL;
	GtkGrid* _tmp44_ = NULL;
	GtkGrid* _tmp45_;
	GtkRadioButton* _tmp46_;
	GtkGrid* _tmp47_;
	GtkRadioButton* _tmp48_;
	GtkGrid* _tmp49_;
	GtkRadioButton* _tmp50_;
	GtkGrid* option_grid = NULL;
	GtkGrid* _tmp51_ = NULL;
	GtkGrid* _tmp52_;
	GtkLabel* _tmp53_;
	GtkGrid* _tmp54_;
	GtkSwitch* _tmp55_;
	GtkGrid* _tmp56_;
	GtkLabel* _tmp57_;
	GtkGrid* _tmp58_;
	GtkSwitch* _tmp59_;
	GtkGrid* _tmp60_;
	GtkLabel* _tmp61_;
	GtkGrid* _tmp62_;
	GtkSwitch* _tmp63_;
	GtkGrid* _tmp64_;
	GtkLabel* _tmp65_;
	GtkGrid* _tmp66_;
	GtkSpinButton* _tmp67_;
	GtkButtonBox* actions = NULL;
	GtkButtonBox* _tmp68_ = NULL;
	GtkButtonBox* _tmp69_;
	GtkButton* _tmp70_;
	GtkButtonBox* _tmp71_;
	GtkButton* _tmp72_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp73_ = NULL;
	GtkGrid* _tmp74_;
	GtkGrid* _tmp75_;
	GtkGrid* _tmp76_;
	GtkGrid* _tmp77_;
	GtkGrid* _tmp78_;
	GtkButtonBox* _tmp79_;
	HdyWindowHandle* window_handle = NULL;
	HdyWindowHandle* _tmp80_;
	HdyWindowHandle* _tmp81_;
	GtkGrid* _tmp82_;
	HdyWindowHandle* _tmp83_;
	GSettings* _tmp84_;
	GSettings* _tmp85_;
	GtkSwitch* _tmp86_;
	GSettings* _tmp87_;
	GSettings* _tmp88_;
	GtkSwitch* _tmp89_;
	GSettings* _tmp90_;
	GSettings* _tmp91_;
	GtkSpinButton* _tmp92_;
	GSettings* _tmp93_;
	GtkSwitch* _tmp94_;
	GSettings* _tmp95_;
	GSettings* _tmp96_;
	GtkRadioButton* _tmp99_;
	GtkRadioButton* _tmp100_;
	GtkRadioButton* _tmp101_;
	GtkSpinButton* _tmp102_;
	GtkSpinButton* _tmp103_;
	GtkButton* _tmp104_;
	GtkButton* _tmp105_;
	GtkSettings* _tmp106_;
	GtkSettings* _tmp107_;
	GtkSettings* _tmp108_;
	GtkSettings* _tmp109_;
	gboolean _tmp110_;
	gboolean _tmp111_;
	parent_class = G_OBJECT_CLASS (screenshot_screenshot_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCREENSHOT_TYPE_SCREENSHOT_WINDOW, ScreenshotScreenshotWindow);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	if (self->priv->from_command) {
		block5_data_unref (_data5_);
		_data5_ = NULL;
		return obj;
	}
	hdy_init ();
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	gtk_window_stick ((GtkWindow*) self);
	_tmp0_ = screenshot_screenshot_backend_new ();
	_g_object_unref0 (self->priv->backend);
	self->priv->backend = _tmp0_;
	_tmp1_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->all);
	self->priv->all = _tmp1_;
	_tmp2_ = self->priv->all;
	_tmp3_ = (GtkImage*) gtk_image_new_from_icon_name ("grab-screen-symbolic", (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	gtk_button_set_image ((GtkButton*) _tmp2_, (GtkWidget*) _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = self->priv->all;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp5_, _ ("Grab the whole screen"));
	_tmp6_ = self->priv->all;
	_tmp7_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp6_);
	g_object_ref_sink (_tmp7_);
	curr_window = _tmp7_;
	_tmp8_ = curr_window;
	_tmp9_ = (GtkImage*) gtk_image_new_from_icon_name ("grab-window-symbolic", (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp9_);
	_tmp10_ = _tmp9_;
	gtk_button_set_image ((GtkButton*) _tmp8_, (GtkWidget*) _tmp10_);
	_g_object_unref0 (_tmp10_);
	_tmp11_ = curr_window;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp11_, _ ("Grab the current window"));
	_tmp12_ = curr_window;
	_tmp13_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp12_);
	g_object_ref_sink (_tmp13_);
	selection = _tmp13_;
	_tmp14_ = selection;
	_tmp15_ = (GtkImage*) gtk_image_new_from_icon_name ("grab-area-symbolic", (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp15_);
	_tmp16_ = _tmp15_;
	gtk_button_set_image ((GtkButton*) _tmp14_, (GtkWidget*) _tmp16_);
	_g_object_unref0 (_tmp16_);
	_tmp17_ = selection;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp17_, _ ("Select area to grab"));
	_tmp18_ = (GtkLabel*) gtk_label_new (_ ("Grab pointer:"));
	g_object_ref_sink (_tmp18_);
	_g_object_unref0 (self->priv->pointer_label);
	self->priv->pointer_label = _tmp18_;
	_tmp19_ = self->priv->pointer_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp19_, GTK_ALIGN_END);
	_tmp20_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->pointer_switch);
	self->priv->pointer_switch = _tmp20_;
	_tmp21_ = self->priv->pointer_switch;
	gtk_widget_set_halign ((GtkWidget*) _tmp21_, GTK_ALIGN_START);
	_tmp22_ = (GtkLabel*) gtk_label_new (_ ("Close after saving:"));
	g_object_ref_sink (_tmp22_);
	close_label = _tmp22_;
	_tmp23_ = close_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_END);
	_tmp24_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp24_);
	close_switch = _tmp24_;
	_tmp25_ = close_switch;
	gtk_widget_set_halign ((GtkWidget*) _tmp25_, GTK_ALIGN_START);
	_tmp26_ = (GtkLabel*) gtk_label_new (_ ("Conceal text:"));
	g_object_ref_sink (_tmp26_);
	redact_label = _tmp26_;
	_tmp27_ = redact_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp27_, GTK_ALIGN_END);
	_tmp28_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp28_);
	redact_switch = _tmp28_;
	_tmp29_ = redact_switch;
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_START);
	_tmp30_ = self->priv->backend;
	_tmp31_ = screenshot_screenshot_backend_get_can_conceal_text (_tmp30_);
	_tmp32_ = _tmp31_;
	if (!_tmp32_) {
		GtkLabel* _tmp33_;
		GtkSwitch* _tmp34_;
		_tmp33_ = redact_label;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp33_, TRUE);
		_tmp34_ = redact_switch;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp34_, TRUE);
	}
	_tmp35_ = (GtkLabel*) gtk_label_new (_ ("Delay in seconds:"));
	g_object_ref_sink (_tmp35_);
	delay_label = _tmp35_;
	_tmp36_ = delay_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp36_, GTK_ALIGN_END);
	_tmp37_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 15, (gdouble) 1);
	g_object_ref_sink (_tmp37_);
	_data5_->delay_spin = _tmp37_;
	_tmp38_ = (GtkButton*) gtk_button_new_with_label (_ ("Take Screenshot"));
	g_object_ref_sink (_tmp38_);
	take_btn = _tmp38_;
	_tmp39_ = take_btn;
	_tmp40_ = gtk_widget_get_style_context ((GtkWidget*) _tmp39_);
	gtk_style_context_add_class (_tmp40_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp41_ = take_btn;
	gtk_widget_set_can_default ((GtkWidget*) _tmp41_, TRUE);
	_tmp42_ = take_btn;
	gtk_window_set_default ((GtkWindow*) self, (GtkWidget*) _tmp42_);
	_tmp43_ = (GtkButton*) gtk_button_new_with_label (_ ("Close"));
	g_object_ref_sink (_tmp43_);
	close_btn = _tmp43_;
	_tmp44_ = (GtkGrid*) gtk_grid_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp44_, GTK_ALIGN_CENTER);
	gtk_grid_set_column_spacing (_tmp44_, 18);
	g_object_ref_sink (_tmp44_);
	radio_grid = _tmp44_;
	_tmp45_ = radio_grid;
	_tmp46_ = self->priv->all;
	gtk_container_add ((GtkContainer*) _tmp45_, (GtkWidget*) _tmp46_);
	_tmp47_ = radio_grid;
	_tmp48_ = curr_window;
	gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
	_tmp49_ = radio_grid;
	_tmp50_ = selection;
	gtk_container_add ((GtkContainer*) _tmp49_, (GtkWidget*) _tmp50_);
	_tmp51_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp51_, 12);
	gtk_grid_set_row_spacing (_tmp51_, 6);
	g_object_ref_sink (_tmp51_);
	option_grid = _tmp51_;
	_tmp52_ = option_grid;
	_tmp53_ = self->priv->pointer_label;
	gtk_grid_attach (_tmp52_, (GtkWidget*) _tmp53_, 0, 0, 1, 1);
	_tmp54_ = option_grid;
	_tmp55_ = self->priv->pointer_switch;
	gtk_grid_attach (_tmp54_, (GtkWidget*) _tmp55_, 1, 0, 1, 1);
	_tmp56_ = option_grid;
	_tmp57_ = close_label;
	gtk_grid_attach (_tmp56_, (GtkWidget*) _tmp57_, 0, 1, 1, 1);
	_tmp58_ = option_grid;
	_tmp59_ = close_switch;
	gtk_grid_attach (_tmp58_, (GtkWidget*) _tmp59_, 1, 1, 1, 1);
	_tmp60_ = option_grid;
	_tmp61_ = redact_label;
	gtk_grid_attach (_tmp60_, (GtkWidget*) _tmp61_, 0, 2, 1, 1);
	_tmp62_ = option_grid;
	_tmp63_ = redact_switch;
	gtk_grid_attach (_tmp62_, (GtkWidget*) _tmp63_, 1, 2, 1, 1);
	_tmp64_ = option_grid;
	_tmp65_ = delay_label;
	gtk_grid_attach (_tmp64_, (GtkWidget*) _tmp65_, 0, 3, 1, 1);
	_tmp66_ = option_grid;
	_tmp67_ = _data5_->delay_spin;
	gtk_grid_attach (_tmp66_, (GtkWidget*) _tmp67_, 1, 3, 1, 1);
	_tmp68_ = (GtkButtonBox*) gtk_button_box_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_set (_tmp68_, "layout-style", GTK_BUTTONBOX_END, NULL);
	gtk_box_set_spacing ((GtkBox*) _tmp68_, 6);
	g_object_ref_sink (_tmp68_);
	actions = _tmp68_;
	_tmp69_ = actions;
	_tmp70_ = close_btn;
	gtk_container_add ((GtkContainer*) _tmp69_, (GtkWidget*) _tmp70_);
	_tmp71_ = actions;
	_tmp72_ = take_btn;
	gtk_container_add ((GtkContainer*) _tmp71_, (GtkWidget*) _tmp72_);
	_tmp73_ = (GtkGrid*) gtk_grid_new ();
	g_object_set ((GtkWidget*) _tmp73_, "margin", 12, NULL);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp73_, 24);
	gtk_grid_set_row_spacing (_tmp73_, 24);
	g_object_ref_sink (_tmp73_);
	grid = _tmp73_;
	_tmp74_ = grid;
	_tmp75_ = radio_grid;
	gtk_grid_attach (_tmp74_, (GtkWidget*) _tmp75_, 0, 0, 1, 1);
	_tmp76_ = grid;
	_tmp77_ = option_grid;
	gtk_grid_attach (_tmp76_, (GtkWidget*) _tmp77_, 0, 1, 1, 1);
	_tmp78_ = grid;
	_tmp79_ = actions;
	gtk_grid_attach (_tmp78_, (GtkWidget*) _tmp79_, 0, 2, 1, 1);
	_tmp80_ = (HdyWindowHandle*) hdy_window_handle_new ();
	g_object_ref_sink (_tmp80_);
	window_handle = _tmp80_;
	_tmp81_ = window_handle;
	_tmp82_ = grid;
	gtk_container_add ((GtkContainer*) _tmp81_, (GtkWidget*) _tmp82_);
	_tmp83_ = window_handle;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp83_);
	_tmp84_ = g_settings_new ("io.elementary.screenshot");
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp84_;
	_tmp85_ = self->priv->settings;
	_tmp86_ = self->priv->pointer_switch;
	g_settings_bind (_tmp85_, "mouse-pointer", (GObject*) _tmp86_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp87_ = self->priv->settings;
	g_settings_bind (_tmp87_, "mouse-pointer", (GObject*) self, "mouse-pointer", G_SETTINGS_BIND_DEFAULT);
	_tmp88_ = self->priv->settings;
	_tmp89_ = close_switch;
	g_settings_bind (_tmp88_, "close-on-save", (GObject*) _tmp89_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp90_ = self->priv->settings;
	g_settings_bind (_tmp90_, "close-on-save", (GObject*) self, "close-on-save", G_SETTINGS_BIND_DEFAULT);
	_tmp91_ = self->priv->settings;
	_tmp92_ = _data5_->delay_spin;
	g_settings_bind (_tmp91_, "delay", (GObject*) _tmp92_, "value", G_SETTINGS_BIND_DEFAULT);
	_tmp93_ = self->priv->settings;
	_tmp94_ = redact_switch;
	g_settings_bind (_tmp93_, "redact", (GObject*) _tmp94_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp95_ = self->priv->settings;
	g_settings_bind (_tmp95_, "redact", (GObject*) self, "redact", G_SETTINGS_BIND_DEFAULT);
	_tmp96_ = self->priv->settings;
	switch (g_settings_get_enum (_tmp96_, "last-capture-mode")) {
		case 1:
		{
			GtkRadioButton* _tmp97_;
			self->priv->capture_mode = SCREENSHOT_CAPTURE_TYPE_CURRENT_WINDOW;
			_tmp97_ = curr_window;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp97_, TRUE);
			break;
		}
		case 2:
		{
			GtkRadioButton* _tmp98_;
			self->priv->capture_mode = SCREENSHOT_CAPTURE_TYPE_AREA;
			_tmp98_ = selection;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp98_, TRUE);
			break;
		}
		default:
		{
			self->priv->capture_mode = SCREENSHOT_CAPTURE_TYPE_SCREEN;
		}
	}
	screenshot_screenshot_window_update_pointer_switch (self);
	_tmp99_ = self->priv->all;
	g_signal_connect_object ((GtkToggleButton*) _tmp99_, "toggled", (GCallback) __screenshot_screenshot_window___lambda15__gtk_toggle_button_toggled, self, 0);
	_tmp100_ = curr_window;
	g_signal_connect_object ((GtkToggleButton*) _tmp100_, "toggled", (GCallback) __screenshot_screenshot_window___lambda16__gtk_toggle_button_toggled, self, 0);
	_tmp101_ = selection;
	g_signal_connect_object ((GtkToggleButton*) _tmp101_, "toggled", (GCallback) __screenshot_screenshot_window___lambda17__gtk_toggle_button_toggled, self, 0);
	_tmp102_ = _data5_->delay_spin;
	g_signal_connect_data (_tmp102_, "value-changed", (GCallback) __screenshot_screenshot_window___lambda18__gtk_spin_button_value_changed, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	_tmp103_ = _data5_->delay_spin;
	self->priv->delay = gtk_spin_button_get_value_as_int (_tmp103_);
	_tmp104_ = take_btn;
	g_signal_connect_object (_tmp104_, "clicked", (GCallback) _screenshot_screenshot_window_take_clicked_gtk_button_clicked, self, 0);
	_tmp105_ = close_btn;
	g_signal_connect_object (_tmp105_, "clicked", (GCallback) __screenshot_screenshot_window___lambda19__gtk_button_clicked, self, 0);
	_tmp106_ = gtk_settings_get_default ();
	_tmp107_ = _g_object_ref0 (_tmp106_);
	_data5_->gtk_settings = _tmp107_;
	_tmp108_ = _data5_->gtk_settings;
	g_signal_connect_data ((GObject*) _tmp108_, "notify::gtk-application-prefer-dark-theme", (GCallback) __screenshot_screenshot_window___lambda20__g_object_notify, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	_tmp109_ = _data5_->gtk_settings;
	g_object_get (_tmp109_, "gtk-application-prefer-dark-theme", &_tmp110_, NULL);
	_tmp111_ = _tmp110_;
	screenshot_screenshot_window_update_icons (self, _tmp111_);
	_g_object_unref0 (window_handle);
	_g_object_unref0 (grid);
	_g_object_unref0 (actions);
	_g_object_unref0 (option_grid);
	_g_object_unref0 (radio_grid);
	_g_object_unref0 (close_btn);
	_g_object_unref0 (take_btn);
	_g_object_unref0 (delay_label);
	_g_object_unref0 (redact_switch);
	_g_object_unref0 (redact_label);
	_g_object_unref0 (close_switch);
	_g_object_unref0 (close_label);
	_g_object_unref0 (selection);
	_g_object_unref0 (curr_window);
	block5_data_unref (_data5_);
	_data5_ = NULL;
	return obj;
}

static void
screenshot_screenshot_window_class_init (ScreenshotScreenshotWindowClass * klass,
                                         gpointer klass_data)
{
	screenshot_screenshot_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ScreenshotScreenshotWindow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_screenshot_screenshot_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_screenshot_screenshot_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = screenshot_screenshot_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = screenshot_screenshot_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCREENSHOT_SCREENSHOT_WINDOW_TO_CLIPBOARD_PROPERTY, screenshot_screenshot_window_properties[SCREENSHOT_SCREENSHOT_WINDOW_TO_CLIPBOARD_PROPERTY] = g_param_spec_boolean ("to-clipboard", "to-clipboard", "to-clipboard", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCREENSHOT_SCREENSHOT_WINDOW_CLOSE_ON_SAVE_PROPERTY, screenshot_screenshot_window_properties[SCREENSHOT_SCREENSHOT_WINDOW_CLOSE_ON_SAVE_PROPERTY] = g_param_spec_boolean ("close-on-save", "close-on-save", "close-on-save", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCREENSHOT_SCREENSHOT_WINDOW_MOUSE_POINTER_PROPERTY, screenshot_screenshot_window_properties[SCREENSHOT_SCREENSHOT_WINDOW_MOUSE_POINTER_PROPERTY] = g_param_spec_boolean ("mouse-pointer", "mouse-pointer", "mouse-pointer", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCREENSHOT_SCREENSHOT_WINDOW_REDACT_PROPERTY, screenshot_screenshot_window_properties[SCREENSHOT_SCREENSHOT_WINDOW_REDACT_PROPERTY] = g_param_spec_boolean ("redact", "redact", "redact", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
screenshot_screenshot_window_instance_init (ScreenshotScreenshotWindow * self,
                                            gpointer klass)
{
	self->priv = screenshot_screenshot_window_get_instance_private (self);
}

static void
screenshot_screenshot_window_finalize (GObject * obj)
{
	ScreenshotScreenshotWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCREENSHOT_TYPE_SCREENSHOT_WINDOW, ScreenshotScreenshotWindow);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->backend);
	_g_object_unref0 (self->priv->pointer_label);
	_g_object_unref0 (self->priv->all);
	_g_object_unref0 (self->priv->pointer_switch);
	G_OBJECT_CLASS (screenshot_screenshot_window_parent_class)->finalize (obj);
}

static GType
screenshot_screenshot_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScreenshotScreenshotWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) screenshot_screenshot_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScreenshotScreenshotWindow), 0, (GInstanceInitFunc) screenshot_screenshot_window_instance_init, NULL };
	GType screenshot_screenshot_window_type_id;
	screenshot_screenshot_window_type_id = g_type_register_static (hdy_application_window_get_type (), "ScreenshotScreenshotWindow", &g_define_type_info, 0);
	ScreenshotScreenshotWindow_private_offset = g_type_add_instance_private (screenshot_screenshot_window_type_id, sizeof (ScreenshotScreenshotWindowPrivate));
	return screenshot_screenshot_window_type_id;
}

GType
screenshot_screenshot_window_get_type (void)
{
	static volatile gsize screenshot_screenshot_window_type_id__once = 0;
	if (g_once_init_enter (&screenshot_screenshot_window_type_id__once)) {
		GType screenshot_screenshot_window_type_id;
		screenshot_screenshot_window_type_id = screenshot_screenshot_window_get_type_once ();
		g_once_init_leave (&screenshot_screenshot_window_type_id__once, screenshot_screenshot_window_type_id);
	}
	return screenshot_screenshot_window_type_id__once;
}

static void
_vala_screenshot_screenshot_window_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	ScreenshotScreenshotWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCREENSHOT_TYPE_SCREENSHOT_WINDOW, ScreenshotScreenshotWindow);
	switch (property_id) {
		case SCREENSHOT_SCREENSHOT_WINDOW_TO_CLIPBOARD_PROPERTY:
		g_value_set_boolean (value, screenshot_screenshot_window_get_to_clipboard (self));
		break;
		case SCREENSHOT_SCREENSHOT_WINDOW_CLOSE_ON_SAVE_PROPERTY:
		g_value_set_boolean (value, screenshot_screenshot_window_get_close_on_save (self));
		break;
		case SCREENSHOT_SCREENSHOT_WINDOW_MOUSE_POINTER_PROPERTY:
		g_value_set_boolean (value, screenshot_screenshot_window_get_mouse_pointer (self));
		break;
		case SCREENSHOT_SCREENSHOT_WINDOW_REDACT_PROPERTY:
		g_value_set_boolean (value, screenshot_screenshot_window_get_redact (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_screenshot_screenshot_window_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	ScreenshotScreenshotWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCREENSHOT_TYPE_SCREENSHOT_WINDOW, ScreenshotScreenshotWindow);
	switch (property_id) {
		case SCREENSHOT_SCREENSHOT_WINDOW_TO_CLIPBOARD_PROPERTY:
		screenshot_screenshot_window_set_to_clipboard (self, g_value_get_boolean (value));
		break;
		case SCREENSHOT_SCREENSHOT_WINDOW_CLOSE_ON_SAVE_PROPERTY:
		screenshot_screenshot_window_set_close_on_save (self, g_value_get_boolean (value));
		break;
		case SCREENSHOT_SCREENSHOT_WINDOW_MOUSE_POINTER_PROPERTY:
		screenshot_screenshot_window_set_mouse_pointer (self, g_value_get_boolean (value));
		break;
		case SCREENSHOT_SCREENSHOT_WINDOW_REDACT_PROPERTY:
		screenshot_screenshot_window_set_redact (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

